/*  

                       Copyright (c) 1990, 1992 by:
        Leif Laaksonen , Centre for Scientific Computing, ESPOO, FINLAND
            Confidential unpublished property of Leif Laaksonen
                        All rights reserved
  

*/

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "maxdefs.h"

 extern void PrintMessage();
 extern int DelManSelectionList();
 extern int yes_no_graph;
 extern int LookRepField();
 extern int ChooseManSelection(char *text1 , char *text2 , char *text3);

     int define_deep=0;
     char define_stack[MAXparse][MAXlinel];
     char define_eq[MAXparse][MAXlinel];


/************************************************************************/
define_fac(input,num)   /* interpret the define command */
   char *input; 
   int num;
/************************************************************************/
{

     extern char parsed[MAXparse][MAXlinel];
     extern int term_type;
     extern int yes_no_graph;

     int k;
     char OutText[BUFF_LEN];

     toller(parsed[1]);

/* help text                                     */
    if(indexo(parsed[1],"?") == 1) {
  PrintMessage("defi*ne dist*ance arra*y s1:r1:a1 s2:r2:a2 [nocr*oss]");
  PrintMessage("                  null ");
  PrintMessage("        angl*e arra*y s1:r1:a1 s2:r2:a2 s3:r3:a3 [nocr*oss]");
  PrintMessage("                  null");
  PrintMessage("        tors*ion arra*y s1:r1:a1 s2:r2:a2 s3:r3:a3 s4:r4:a4 [nocr*oss]");
  PrintMessage("                  null");
  PrintMessage("        atom  list        seg:res:atm    ! define a selection list");
  PrintMessage("        atom  sele*ction  seg:res:atm    ! define a selection list");
  PrintMessage("             -lis*t                ! delete the selection list");
  PrintMessage("             -sel*ection           ! delete the selection list");
    return;}

/* define colour                                 */
/* the command should look like this: 
       define colour name  nr1 nr2 n3  */

     if(indexo(parsed[1],"colo") == 1) {
     if(num < 7) { /* too few parameters on line */
       printf("?ERROR - incomplete set colour command \n");
       return;}
        strncpy(define_eq[define_deep],parsed[1],MAXlinel);
        for(k = 2 ; k < num ; k++)  {
         strcat(define_stack[define_deep]," ");
         strcat(define_stack[define_deep],parsed[k]);}
         if(define_deep == MAXparse) {
         printf("?ERROR - define stack is full \n");
         return;}
        define_deep++;
     return;}

/* define point vector              */
     if(indexo(parsed[1],"poin") == 1) {
        toller(parsed[2]);
          if(indexo(parsed[2],"arra") == 1 || 
             indexo(parsed[2],"vect") == 1 ||
             indexo(parsed[2],"list") == 1) {
/* fake the program to use no graphics if it is using now */
          k = yes_no_graph;
          yes_no_graph = 0;
          study_dynamics(8);
          yes_no_graph = k;
          return;}
          if(indexo(parsed[2],"null") == 1) {
          study_dynamics(16);
          return;}
     }
        
/* define distance vector          */
     if(indexo(parsed[1],"dist") == 1) {
       toller(parsed[2]);
          if(indexo(parsed[2],"arra") == 1 || 
             indexo(parsed[2],"vect") == 1 ||
             indexo(parsed[2],"list") == 1) {
          
          (void)LookRepField( 2 , parsed[3]);

/* fake the program to use no graphics if it is using now */
          k = yes_no_graph;
          yes_no_graph = 0;
          study_dynamics(3);
          yes_no_graph = k;
          return;}
          if(indexo(parsed[2],"null") == 1) {
          study_dynamics(16);
          return;}
     }
     if(indexo(parsed[1],"angl") == 1) {
       toller(parsed[2]);
          if(indexo(parsed[2],"arra") == 1 || 
             indexo(parsed[2],"vect") == 1 ||
             indexo(parsed[2],"list") == 1) {
          
          (void)LookRepField( 3 , parsed[3]);

/* fake the program to use no graphics if it is using now */
          k = yes_no_graph;
          yes_no_graph = 0;
          study_dynamics(4);
          yes_no_graph = k;
          return;}
          if(indexo(parsed[2],"null") == 1) {
          study_dynamics(16);
          return;}
     }
     if(indexo(parsed[1],"tors") == 1) {
       toller(parsed[2]);
          if(indexo(parsed[2],"arra") == 1 || 
             indexo(parsed[2],"vect") == 1 ||
             indexo(parsed[2],"list") == 1) {

          (void)LookRepField( 4 , parsed[3]);

/* fake the program to use no graphics if it is using now*/
          k = yes_no_graph;
          yes_no_graph = 0;
          study_dynamics(5);
          yes_no_graph = k;
          return;}
          if(indexo(parsed[2],"null") == 1) {
          study_dynamics(16);
          return;}
     }

/* define no graphics       */
     if(indexo(parsed[1],"grap") == 1) {
       toller(parsed[2]);
          if(indexo(parsed[2],"on") == 1) {
            if(term_type == 1 || term_type == 3) {
            yes_no_graph = 1;
            return;}
            else {
            printf("?ERROR - this is a non graphics device \n");
            return;}}

          if(indexo(parsed[2],"off") == 1) {
            yes_no_graph = 0;
            return;}
     }

/* atom list               */
     if(indexo(parsed[1],"atom") == 1) {
       toller(parsed[2]);
       if(indexo(parsed[2],"list") == 1 ||
          indexo(parsed[2],"sele") == 1) {
          if(ChooseManSelection(parsed[3] , parsed[4] , parsed[5])) {
             PrintMessage("?ERROR - in atom selection");
	   }
          return;
       }
       if(indexo(parsed[2],"-lis") == 1 ||
          indexo(parsed[2],"-sel") == 1) {
          if(DelManSelectionList()) {
             PrintMessage("?ERROR - can't delete NULL list");
	  }
          return;
       }
     }

/* default position "command not recognized"  */

     sprintf(OutText,"?ERROR: Following command not recognized: %s \n",input);
     PrintMessage(OutText);

}      /* end of define_fac */

